#! /usr/local/bin/wish8.3  -f



###############setcolors###############
set COL(1) black
set COL(2) #444
set COL(3) #666
set COL(4) #999
set COL(5) #ddd
set COL(6) white
set COL(7) #ff0
set COL(8) #db0
set COL(9) #06f
set COL(10) #00f
set COL(11) #f00
set COL(12) #b00
set COL(13) #0f2
set COL(14) #0a0
set COL(15) #f0d
set COL(16) #b08
#############################################





##########################FILE READ######
proc file_read {window} {
global file1 file2 WINDOW COL
set WINDOW $window
##
set file1 [open Graphics/Data/out1 r]
gets $file1 result
if {$result<=16} {
$window itemconfigure backg -fill $COL($result)
}
close $file1
##
set file2 [open Graphics/Data/out2 r]
while {[gets $file2 line] >= 0} {
set data_type $line
if {$data_type == 1} {arc_write}
if {$data_type == 2} {point_write}
if {$data_type == 3} {segment_write}
if {$data_type == 4} {polygon_write}
if {$data_type == 5} {text_print}
}
close $file2
}
###############################################





##########################TEXT READ######
proc text_read {window} {
global file WINDOW
set WINDOW $window
##
set file [open Graphics/Data/out3 r]
while {[gets $file line] >= 0} {
set data_type $line
if {$data_type == 5} {text_print}
}
##
close $file
}
###############################################





###############################################
proc point_write {} {
global COL file2 WINDOW
foreach name {s1 p1 p2} {
gets $file2 line
set dot_size 0
set $name $line }
$WINDOW create oval [expr $p1-$dot_size] [expr $p2-$dot_size] \
[expr $p1 +$dot_size] [expr $p2+$dot_size] \
-fill $COL($s1) -outline $COL($s1) -tag new
}
###############################################



###############################################
proc arc_write {} {
global COL file2 WINDOW
foreach name {s1 p1 p2 q1 q2 a1 a2} {
gets $file2 line
set $name $line }
$WINDOW create arc $p1 $p2 $q1 $q2 -fill black \
-outline $COL($s1) -start $a1  -extent $a2 -style arc -tag new  
}
###############################################



###############################################
proc segment_write {} {
global COL file2 WINDOW
foreach name {s1 p1 p2 s2 q1 q2} {
gets $file2 line
set $name $line }
set pp1 [expr -$p1]
set pp2 [expr -$p2]
set qq1 [expr -$q1]
set qq2 [expr -$q2]
$WINDOW create line $p1 $p2 $q1 $q2 \
-fill $COL($s1)  -tag new -width 1
}
###############################################



###############################################
proc polygon_write {} {
global COL file2 WINDOW RENDER
set list {}
set PI [expr 3.14159265]
gets $file2 line
set s1 $line
gets $file2 line
set s2 $line

while {$line !=-999999999} {
set old $line
gets $file2 line
if {$line!=-999999999} {
lappend list $line }
}
$WINDOW create polygon $list -fill $COL($s1) \
 -outline $COL($s2) -tag new

if {$RENDER==1} {
$WINDOW create polygon $list -fill $COL($s1) \
 -outline $COL($s2) -tag new2
set xval [lindex $list 0]
if {$xval<[expr -$PI]} {
$WINDOW move new2 [expr 2*$PI] 0
}
if {$xval>=[expr -$PI]} {
$WINDOW move new2 [expr -2*$PI] 0
}
$WINDOW addtag new withtag new2
$WINDOW dtag new2
$WINDOW raise blinders
}

}
###############################################



###############################################
proc text_print {} {
global COL file2 WINDOW
foreach name {c p1 p2 s} {
gets $file2 line
set $name $line } 
$WINDOW create text $p1 $p2 -text "$s" -fill $COL($c) -tag labels
$WINDOW addtag new withtag labels
}
###############################################


